<script type="text/javascript">


var InterfaceTapas = Class.create( {
    initialize: function( jsonFileFormats, jsonYesNos, jsonObservatories, jsonSpectralUnits, jsonInstrumentalFunctions, jsonClimatoReferences )
    {
        /** *********** CONTAINERS *********** **/
        this.containerForm = $( "#formulaire" );
        //this.containerErrors = $( "#errForm" );
        //this.divE= $( "#divErreurs");
        this.containerCenter = $( "#containerCenter" );
        this.containerTabs = $( "#tab" );

        /** *********** VARIABLES *********** **/
        this.jSonFileFormats = jsonFileFormats || null;
        this.selectFileFormatsList = new Object();

        this.jSonYesNos = jsonYesNos || null;
        this.select_ih2oeList = new Object();
        this.select_io2eList = new Object();
        this.select_io3eList = new Object();
        this.select_ico2eList = new Object();
        this.select_irextinctionList = new Object();

        this.jSonObservatories = jsonObservatories || false;
        this.selectObservatoriesList = new Object();
        this.jSonSpectralUnits = jsonSpectralUnits || null;
        this.selectSpectralUnitsList = new Object();
        this.jSonInstrumentalFunctions = jsonInstrumentalFunctions || null;
        this.selectInstrumentalFunctionsList = new Object();
        this.jSonClimatoReferences = jsonClimatoReferences || null;
        this.selectClimatoReferencesList = new Object();
        this.nbRequest = 1;
        this.tabActive = false;
        this.numRequest = 1;

        // Buttons
        var submitButton = new Button( {value:tapasTexts["label.submitButton"], parent:this.containerCenter, id:"button_submit", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickSubmit, this )} );
        this.addRequestButton = new Button( {title:tapasTexts["label.title.add"],value:tapasTexts["label.addButton"], parent:this.containerCenter, id:"button_add", className: "positive", onClick:jQuery.proxy( this.onClickAdd, this )} );
        this.delRequestButton = new Button( {title:tapasTexts["label.title.del"],value:tapasTexts["label.delButton"], parent:this.containerCenter, id:"button_del", className: "negative", onClick:jQuery.proxy( this.onClickDel, this )} );
        this.delRequestButton.disable();

        this.createForm();
        this.tabActive = this.createTab();
        this.divE = $( document.createElement( "div" ) );
        this.divE.attr( {id:"divErrors", class:"errorsForm"} );
        /*var fieldSetE = $( document.createElement( "fieldset" ) );
         fieldSetE.addClass( "cfs3" );
         this.divE.append( fieldSetE );*/

        this.containerForm.append( this.divE );
        //this.containerErrors.hide();
        this.divE.hide();

        /** *********** LOADING *********** **/
        var param = new Object();
        param.id = "loadingForRequest";
        param.parent = this.containerForm;
        param.className = "loading-classic";
        this.loadingRequest = new Loading( param );
        //this.loadingRequest.display();
    },


    // CREATES ********************************************************
    createTab:function()
    {
        var ntab = new Tab( {value:tapasTexts["label.requete"] + " " + this.nbRequest, parent:this.containerTabs, numTab: this.nbRequest, id:"tab_request" + this.nbRequest, className: "tab_class", onClick:jQuery.proxy( this.onClickTab, this )} );
        ntab.active();
        return ntab;
    },


    createCalendar: function( containerCalendar, texte, inputDateId, currentDate, isTrToCreate )
    {
        if( isTrToCreate )
        {
            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"17"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );
            tr.append( td1 );

            td2.attr( {colspan:4} );
            td2.append( inputDate );
            tr.append( td2 );
            containerCalendar.append( tr );
        }

        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i:%s";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( inputDateId, { format: this.calendarFormat, firstDOW: 1,
            labelTitle: "Select Date", labelYear: "Year", labelMonth: "Month", labelDayOfMonth: "Day",
            labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        // Ajout de la date courrante ds le calendrier SI currentDate non précisée
        if( !currentDate )
            currentDate = new Date();

        $( "#" + inputDateId ).val( this.calendarConverter.format( currentDate ) );
        $( "#" + inputDateId ).addClass( "calendar" );

    },


    // CREATES ********************************************************
    createTime: function( containerCalendar, texte, inputDateId, currentTime, isTrToCreate )
    {
        if( isTrToCreate )
        {
            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"10"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );

            tr.append( td1 );


            td2.attr( {colspan:3} );
            td2.append( inputDate );
            tr.append( td2 );
            containerCalendar.append( tr );
        }

        // Time
        this.timeFormat = "%H:%i:%s";
        this.timeConverter = new AnyTime.Converter( { format: this.timeFormat } );

        AnyTime.picker( inputDateId, { format: this.timeFormat, firstDOW: 1,
            labelTitle: "Select hour", labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        if( !currentTime )
            currentTime = "00:00:00";
        // TODO : voir si besoin de convertir format des heures
//        $( "#" + inputDateId ).val( this.timeConverter.format( currentTime ) );
        $( "#" + inputDateId ).val( currentTime );
        $( "#" + inputDateId ).addClass( "time" );
    },


    createTr: function( texte, inputId, container, textesup )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId, class:"containerText", size:11} );

        td1.html( texte );
        td1.attr( {class:"containerLabel"} );

        td3.html( textesup );
        td3.attr( {class:"containerLabel2", colspan:3} );
        tr.append( td1 );
        td2.append( input );

        tr.append( td2 );
        tr.append( td3 );
        container.append( tr );

    },

    createTr2Input: function( texte1, texte2, inputId1, inputId2, container, textesup )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var td4 = $( document.createElement( "td" ) );
        var td5 = $( document.createElement( "td" ) );
        var input1 = $( document.createElement( "input" ) );
        var input2 = $( document.createElement( "input" ) );


        input1.attr( {id: inputId1,class:"containerText",size:11} );
        input2.attr( {id: inputId2,class:"containerText",size:11} );

        td1.html( texte1 );
        td3.html( texte2 );
        td5.html( textesup );
        td1.attr( {class:"containerLabel"} );
        td3.attr( {class:"containerLabel3"} );
        td5.attr( {class:"containerLabel2"} );

        td2.append( input1 );
        //td2.html( texte2 );
        td4.append( input2 );

        tr.append( td1 );
        tr.append( td2 );
        tr.append( td3 );
        tr.append( td4 );
        tr.append( td5 );
        container.append( tr );
    },



    createTrList: function( texte, inputId, index, container, type )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId} );

        td1.html( texte );
        td1.attr( {class:"containerLabel"} );
        tr.append( td1 );

        if( 'format' == type ) this.displaySelect( td2, inputId, index, this.jSonFileFormats, this.selectFileFormatsList, false, null );
        else
        if( 'yesno' == type )
        {
            if( (/^(ih2oe_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ih2oeList, false, "yesNos" );
            else if( (/^(io2e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_io2eList, false, "yesNos" );
            else if( (/^(io3e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_io3eList, false, "yesNos" );
            else if( (/^(ico2e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ico2eList, false, "yesNos" );
            else if( (/^(irextinction_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_irextinctionList, false, "yesNos" );
        }
        else if( 'observatories' == type )
            this.displaySelect( td2, inputId, index, this.jSonObservatories, this.selectObservatoriesList, true, "observatories" );
        else if( 'spectralUnit' == type )
            this.displaySelect( td2, inputId, index, this.jSonSpectralUnits, this.selectSpectralUnitsList, true, "spectralUnits" );
        else if( 'ilsf' == type )
            this.displaySelect( td2, inputId, index, this.jSonInstrumentalFunctions, this.selectInstrumentalFunctionsList, false, "instrumentalFunctions" );
        else if( 'climatoReference' == type )
            this.displaySelect( td2, inputId, index, this.jSonClimatoReferences, this.selectClimatoReferencesList, false, "climatoReferences" );

        td2.attr( {colspan:3} );
        tr.append( td2 );
        container.append( tr );
    },


    // REQUESTS ********************************************************
    requestCreateXML: function()
    {
        var tapasForm = this.createTapasObject();
        //passage de javascript a json grace au jquery
        var jsonTapasForm = $.toJSON( tapasForm );


        if( jsonTapasForm )
            $.ajax( {
                url: "data?methodName=createUserRequest&jsonTapas=" + jsonTapasForm,
                success:jQuery.proxy( this.handleCreateXML, this ),
                error: jQuery.proxy( this.showErrors, this )
            } );

    },


    // HANDLES ******************************************************** = retours ajax
    handleCreateXML: function( result )
    {
        this.loadingRequest.hide();
        //this.loadingRequest.display();

        var res = jQuery.parseJSON( result ).result;
        alert( res );
    },


    // EVENTS ********************************************************
    onClickSubmit: function()
    {
        if( this.validFields() )
        {
            this.divE.hide();
            if( confirm( tapasTexts["confirm"] ) )
            {
                this.loadingRequest.display();
                this.requestCreateXML();
            }
        }
    },


    onClickAdd: function()
    {
        this.divE.hide();
        this.nbRequest++;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        this.tabActive = this.createTab();
        this.numRequest = this.tabActive.numTab;

        //formulaires
        $( ".divAll" ).hide();
        this.createForm();

        this.updateButtons();
    },


    onClickDel: function()
    {
        if( confirm( tapasTexts["label.confirm.del"] ) )
        {
            var numCurrent = this.numRequest;
            var z = 1;

            //suppression onglet et form et controles calendrier caché
            $( "#all_" + numCurrent ).remove();
            $( "#tab_request" + numCurrent ).remove();
            AnyTime.noPicker( "iobservation_date_" + numCurrent );
            AnyTime.noPicker( "ira_" + numCurrent );

            this.tabActive.numTab = "1";
            this.numRequest = "1";

            this.selectClimatoReferencesList[numCurrent] = null;

            for( var i = 1; i <= this.nbRequest; i++ )
            {
                if( i > numCurrent )
                {
                    z = i - 1;
                    document.getElementById( "all_" + i ).id = "all_" + z;
                    $( "#tab_request" + i ).html( "Request " + z );
                    $( "#tab_request" + i ).attr( {name:z} );
                    $( "#tab_request" + i ).attr( {id:"tab_request" + z} );
                    $( "#tabObservation_" + i ).attr( {id:"tabObservation_" + z} );
//                    $( "#select_iobservatory_" + i ).attr( {id:"select_iobservatory_" + z} );
                    this.selectObservatoriesList[z] = this.selectObservatoriesList[i];
                    this.selectObservatoriesList[i] = null;
//                    $( "#select_ispectral_choice_" + i ).attr( {id:"select_ispectral_choice_" + z} );
                    this.selectSpectralUnitsList[z] = this.selectSpectralUnitsList[i];
                    this.selectSpectralUnitsList[i] = null;
                    $( "#iminspectral_ranger_" + i ).attr( {id:"iminspectral_ranger_" + z} );
                    $( "#imaxspectral_ranger_" + i ).attr( {id:"imaxspectral_ranger_" + z} );
//                    $( "#select_ifunction_" + i ).attr( {id:"select_ifunction_" + z} );
                    this.selectInstrumentalFunctionsList[z] = this.selectInstrumentalFunctionsList[i];
                    this.selectInstrumentalFunctionsList[i] = null;
//                    $( "#select_icr_" + i ).attr( {id:"select_icr_" + z} );
                    this.selectClimatoReferencesList[z] = this.selectClimatoReferencesList[i];
                    this.selectClimatoReferencesList[i] = null;
                    $( "#ide_" + i ).attr( {id:"ide_" + z} );
                    $( "#iza_" + i ).attr( {id:"iza_" + z} );
                    $( "#irp_" + i ).attr( {id:"irp_" + z} );
                    $( "#isr_" + i ).attr( {id:"isr_" + z} );
//                    $( "#select_iformat_" + i ).attr( {id:"select_iformat_" + z} );
                    this.selectFileFormatsList[z] = this.selectFileFormatsList[i];
                    this.selectFileFormatsList[i] = null;
//                    $( "#select_irextinction_" + i ).attr( {id:"select_irextinction_" + z} );
                    this.select_irextinctionList[z] = this.select_irextinctionList[i];
                    this.select_irextinctionList[i] = null;
//                    $( "#select_ih2oe_" + i ).attr( {id:"select_ih2oe_" + z} );
                    this.select_ih2oeList[z] = this.select_ih2oeList[i];
                    this.select_ih2oeList[i] = null;
//                    $( "#select_io2e_" + i ).attr( {id:"select_io2e_" + z} );
                    this.select_io2eList[z] = this.select_io2eList[i];
                    this.select_io2eList[i] = null;
//                    $( "#select_io3e_" + i ).attr( {id:"select_io3e_" + z} );
                    this.select_io3eList[z] = this.select_io3eList[i];
                    this.select_io3eList[i] = null;
//                    $( "#select_ico2e_" + i ).attr( {id:"select_ico2e_" + z} );
                    this.select_ico2eList[z] = this.select_ico2eList[i];
                    this.select_ico2eList[i] = null;

                    // Supression du calendrier puis re-création en insérant l'ancienne date
                    var oldDate = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() );
                    AnyTime.noPicker( "iobservation_date_" + i );
                    this.createCalendar( $( "#tabObservation_" + z ), tapasTexts["label.datemesure"], "iobservation_date_" + z, oldDate, false );
                    $( "#iobservation_date_" + i ).attr( {id:"iobservation_date_" + z} );

                    // Idem pour les heures !!!
                    // TODO : voir si besoin de parser les heures ou non
//                    var oldTime = this.timeConverter.parse( $( "#ira_" + i ).val() );
                    var oldTime = $( "#ira_" + i ).val();
                    AnyTime.noPicker( "ira_" + i );
                    this.createTime( $( "#tabObservation_" + z ), tapasTexts["label.ira"], "ira_" + z, oldTime, false );
                    $( "#ira_" + i ).attr( {id:"ira_" + z} );
                }
            }

            this.nbRequest--;

            // Mise à jour des boutons
            this.updateButtons();

            //tabs
            $( ".tab_class" ).removeClass( "activated" );
            $( "#tab_request1" ).addClass( "activated" );

            //formulaires
            $( ".divAll" ).hide();
            $( "#all_1" ).show();
        }
    },


    onClickTab: function( event )
    {
        var realTabId = $( "#" + event.currentTarget.id ).attr( "name" );
        var clickedDiv = event.data;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        clickedDiv.divContainer.addClass( "activated" );

        //forms
        $( ".divAll" ).hide();
        $( "#all_" + realTabId ).show();

        this.numRequest = realTabId;
        this.tabActive.numTab = realTabId;

        this.updateButtons();
    },


    // OTHERS ********************************************************
    // General method to display select
    displaySelect: function( container, id, index, jsonList, selectList, nullValueIsNeeded, contentManage )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        var select = new Select( paramSelect );
        if( nullValueIsNeeded )
            select.add( "-1", "-- " + tapasTexts["text.select"] + " --" );
        jQuery.each( jsonList, jQuery.proxy( function ( i, jsonElement )
        {
            switch( contentManage )
            {
                case "observatories":
                    select.add( jsonElement.id, jsonElement.name );
                    break;
                case "spectralUnits":
                    select.add( jsonElement.value, tapasTexts[jsonElement.value] );
                    break;
                case "instrumentalFunctions" :
                case "climatoReferences" :
                case "yesNos" :
                    select.add( jsonElement.value, tapasTexts[jsonElement.text] );
                    break;
                default:
                    select.add( jsonElement.value, jsonElement.text );
                    break;
            }
        }, this ) );
        select.selectFirst( false );
        selectList[index] = select;
    },

    showErrors: function( result )
    {
        //this.containerErrors.show();
        // this.containerErrors.html( tapasTexts[result.responseText] );
    },

    createForm: function()
    {

        var divAll = $( document.createElement( "div" ) );
        divAll.attr( {id:"all_" + this.nbRequest, class:"divAll"} );


        //Creation div
        var divPreference = $( document.createElement( "div" ) );
        var tabPreference = $( document.createElement( "table" ) );
        tabPreference.attr( {cellspacing:3} );

        var divObservation = $( document.createElement( "div" ) );
        var tabObservation = $( document.createElement( "table" ) );
        //tabObservation.attr({border:1});
        tabObservation.attr( {id:"tabObservation_" + this.nbRequest, cellspacing:3} );


        var divAtmosphere = $( document.createElement( "div" ) );
        var tabAtmosphere = $( document.createElement( "table" ) );


        var fieldSetObservation = $( document.createElement( "fieldset" ) );
        fieldSetObservation.addClass( "cfs1" );
        divObservation.append( fieldSetObservation );

        var legendObservation = $( document.createElement( "legend" ) );
        legendObservation.html( "Observation" );
        fieldSetObservation.append( legendObservation );
        legendObservation.addClass( "containerField" );

        var fieldSetPreference = $( document.createElement( "fieldset" ) );
        fieldSetPreference.addClass( "cfs2" );
        divPreference.append( fieldSetPreference );

        var legendPreference = $( document.createElement( "legend" ) );
        legendPreference.html( tapasTexts["label.preferences"] );
        fieldSetPreference.append( legendPreference );
        legendPreference.addClass( "containerField" );

        fieldSetObservation.append( tabObservation );
        divObservation.addClass( "divObservation" );
        divAll.append( divObservation );


        divAtmosphere.append( tabAtmosphere );
        //divAtmosphere.addClass("divAtmosphere");
        //this.containerForm.append( divAtmosphere );
        fieldSetObservation.append( divAtmosphere );

        fieldSetPreference.append( tabPreference );
        divPreference.addClass( "divPreference" );
        divAll.append( divPreference );

        this.containerForm.append( divAll );
        this.containerForm.append( this.divE );
        //this.tabInput = new Array(3);

        this.createTrList( tapasTexts["label.format"], "iformat_" + this.nbRequest, this.nbRequest, tabPreference, 'format' );
        this.createTrList( tapasTexts["label.era"], "irextinction_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eh2o"], "ih2oe_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eo3"], "io3e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eo2"], "io2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eco2"], "ico2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );

        this.createTrList( tapasTexts["label.observatory"], "iobservatory_" + this.nbRequest, this.nbRequest, tabObservation, 'observatories' );
        this.createCalendar( tabObservation, tapasTexts["label.datemesure"], "iobservation_date_" + this.nbRequest, false, true );

        //unite
        this.createTrList( tapasTexts["label.spectralUnit"], "ispectral_choice_" + this.nbRequest, this.nbRequest, tabObservation, 'spectralUnit' );
        this.createTr2Input( tapasTexts["label.spectralRange"], tapasTexts["label.to"], "iminspectral_ranger_" + this.nbRequest, "imaxspectral_ranger_" + this.nbRequest, tabObservation, "[350,2500] nm" );

        //fonction instrumentale
        this.createTrList( tapasTexts["label.ifunction"], "ifunction_" + this.nbRequest, this.nbRequest, tabObservation, "ilsf" );
        //reference climato
        //this.createTrList( tapasTexts["label.climato"], "icr", tabAtmosphere, "climatoReference" );
        this.createTrList( tapasTexts["label.climato"], "icr_" + this.nbRequest, this.nbRequest, tabObservation, "climatoReference" );


        //this.createTr( tapasTexts["label.ira"], "ira", tabObservation );
        this.createTime( tabObservation, tapasTexts["label.ira"], "ira_" + this.nbRequest, false, true );
        this.createTr( tapasTexts["label.ide"], "ide_" + this.nbRequest, tabObservation, "hh:mm:ss.ms [-90,90] &deg;" );
        this.createTr( tapasTexts["label.iza"], "iza_" + this.nbRequest, tabObservation, "[0,90] &deg;" );

        this.createTr( tapasTexts["label.resolution"], "irp_" + this.nbRequest, tabObservation, "" );
        this.createTr( tapasTexts["label.ratio"], "isr_" + this.nbRequest, tabObservation, "" );


        //jQuery.proxy permet d'envoyer le contexte this courant

    },


    createTapasObject: function()
    {

        var requests = new Array();

        for( var i = 1; i <= this.nbRequest; i++ )
        {
            // PREFERENCE
            var preference = new Object();

            preference.format = new Object();
            //toutes les valeurs possibles
            preference.format.firstValue = this.selectFileFormatsList[i].getValuesInString();
            //la valeur selectionnee
            preference.format.secondValue = this.selectFileFormatsList[i].getValue();

            preference.rayleighExtinction = new Object();
            preference.rayleighExtinction.firstValue = this.select_irextinctionList[i].getValuesInString();
            preference.rayleighExtinction.secondValue = this.select_irextinctionList[i].getValue();

            preference.h2oExtinction = new Object();
            preference.h2oExtinction.firstValue = this.select_ih2oeList[i].getValuesInString();
            preference.h2oExtinction.secondValue = this.select_ih2oeList[i].getValue();

            preference.o3Extinction = new Object();
            preference.o3Extinction.firstValue = this.select_io3eList[i].getValuesInString();
            preference.o3Extinction.secondValue = this.select_io3eList[i].getValue();

            preference.o2Extinction = new Object();
            preference.o2Extinction.firstValue = this.select_io2eList[i].getValuesInString();
            preference.o2Extinction.secondValue = this.select_io2eList[i].getValue();

            preference.co2Extinction = new Object();
            preference.co2Extinction.firstValue = this.select_ico2eList[i].getValuesInString();
            preference.co2Extinction.secondValue = this.select_ico2eList[i].getValue();


            // OBSERVATION
            var observatory = new Object();
            observatory.id = this.selectObservatoriesList[i].getValue();

            // Los
            var los = new Object();
            los.raJ2000 = $( "#ira_" + i ).val();
            los.decJ2000 = $( "#ide_" + i ).val();
            los.zenithAngle = $( "#iza_" + i ).val();

            // Instrument
            var instrument = new Object();
            instrument.ilsfChoice = new Object();
            instrument.ilsfChoice.firstValue = "-1,0,1";//this.selectInstrumentalFunctionsList[i].getValuesInString();
            instrument.ilsfChoice.secondValue = this.selectInstrumentalFunctionsList[i].getValue();

            this.selectSpectralUnitsList[i].remove( "-1" );
            instrument.spectralChoice = new Object();
            instrument.spectralChoice.firstValue = this.selectSpectralUnitsList[i].getValuesInString();
            instrument.spectralChoice.secondValue = this.selectSpectralUnitsList[i].getValue();

            instrument.spectralRange = $( "#iminspectral_ranger_" + i ).val() + ' ' + $( "#imaxspectral_ranger_" + i ).val();

            instrument.resolvingPower = new Object();
            instrument.resolvingPower.firstValue = "0";
            instrument.resolvingPower.secondValue = $( "#irp_" + i ).val();

            instrument.samplingRatio = new Object();
            instrument.samplingRatio.firstValue = "0";
            instrument.samplingRatio.secondValue = $( "#isr_" + i ).val();

            var observation = new Object();
            observation.date = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() ).getTime();
            observation.observatory = observatory;

            observation.los = los;
            observation.instrument = instrument;

            // ATMOSPHERE
            var atmosphere = new Object();

            atmosphere.reference = new Object();
            atmosphere.reference.firstValue = this.selectClimatoReferencesList[i].getValuesInString();
            atmosphere.reference.secondValue = this.selectClimatoReferencesList[i].getValue();


            // REQUEST
            var request = new Object();
            request.id = i;
            request.preference = preference;
            request.observation = observation;
            request.atmosphere = atmosphere;

            requests[i - 1] = request;
        }

        // TAPAS
        var tapas = new Object();
        tapas.requests = requests;
        return tapas;
    },

    validFields: function()
    {
        for( var i = 1; i <= this.nbRequest; i++ )
        {

            var chaine = tapasTexts["text.erreur.saisie"] + " " + i + "<br>";
            var testOk = isSup( this.selectObservatoriesList[i].getValue(), 0 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.observatory"] + " : " + tapasTexts["text.toselect"] );
                this.divE.show();
                return false;
            }

            testOk = isDiff( this.selectSpectralUnitsList[i].getValue(), -1 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.spectralUnit"] + " : " + tapasTexts["text.toselect"] );
                this.divE.show();
                return false;
            }

            testOk = isValidRange( $( "#iminspectral_ranger_" + i ).val(), $( "#imaxspectral_ranger_" + i ).val(), this.selectSpectralUnitsList[i].getValue() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.spectralRange"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isDeg( $( "#ide_" + i ).val() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.ide"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isValidNum( $( "#iza_" + i ).val() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isBetween( $( "#iza_" + i ).val(), 0, 90 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isValidNum( $( "#irp_" + i ).val() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isSup( $( "#irp_" + i ).val(), 1 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isValidNum( $( "#isr_" + i ).val() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isSup( $( "#isr_" + i ).val(), 1 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }
        }

        return true;
    },

    updateButtons: function()
    {
        if( 1 < this.nbRequest )
            this.delRequestButton.enable();
        else
            this.delRequestButton.disable();

        if( 9 <= this.nbRequest )
            this.addRequestButton.disable();
        else
            this.addRequestButton.enable();
    }

} );

</script>
